'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = combineStores;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _rxjs = require('rxjs');

var _isObservable = require('fluorine-lib/lib/util/isObservable');

var _isObservable2 = _interopRequireDefault(_isObservable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function combineStores(stores) {
  (0, _invariant2.default)((typeof stores === 'undefined' ? 'undefined' : (0, _typeof3.default)(stores)) === 'object', 'combineStores: `stores` is expected to be an object containing Observables.');

  var keys = (0, _keys2.default)(stores);

  return _rxjs.Observable.combineLatest.apply(_rxjs.Observable, keys.map(function (key) {
    var store = stores[key];

    (0, _invariant2.default)((0, _isObservable2.default)(store), 'combineStores: `stores` is expected to contain Observables only.');

    return store;
  }).concat([function () {
    for (var _len = arguments.length, values = Array(_len), _key = 0; _key < _len; _key++) {
      values[_key] = arguments[_key];
    }

    return values.reduce(function (acc, val, index) {
      acc[keys[index]] = val;
      return acc;
    }, {});
  }]));
}